import libglade
import gtk
import string
from core import *
from image import *
from time import *

not_available_string = "[n/a]"

class Event(FamiliarClass):
    def __init__(self):
        self.mimetype = "application/x-event"
        self.name = [] # 1: what in vcal is known as a summary. 2: string id
        self.start_date = None
        self.end_date = None
        self.description = ""
        self.id = time()
        FamiliarClass.__init__(self)

    def set_name(self, name):
        for i in range(0,len(name)):
            if i >= len(self.name):
                self.name.append(name[i])
            else:
                self.name[i] = name[i]

    def get_name(self):
        return self.name[:]

    def set_start_date(self, startdate):
        self.start_date = (startdate[0:5])
        
    def get_start_date(self):
        return self.start_date

    def set_end_date(self, startdate):
        self.end_date = startdate
        
    def get_end_date(self):
        return self.end_date

    def set_summary(self,summary):
        self.name=[]
        self.name.append(summary)

    def get_summary(self):
        try:
            return self.name[0]
        except:
            return not_available_string

    def get_id(self):
        return self.id

    def set_description(self,descript):
        self.description=descript
        lines=string.split(descript,'\n',1)
        self.set_summary(lines[0])

    def get_description(self):
        return self.description

    def new_view(self):
        # XXX - This should be routed through the ObjectManager
        return EventView(self)

    def get_printable_name(self):
        # XXX - This needs to be moved into the view.
        name = self.get_name()
        try:
            full_name = string.join([name[0], name[1]], ":")
        except:
            full_name = name[0]
        return full_name
    

class EventView(FamiliarClassView):
    def __init__(self, object):
        self.object = object
        self.callback_object_list = []
        FamiliarClassView.__init__(self)
        
    def view(self,function):
        self.helper = GladeHelper("familiar/event.glade",
                                  EventSignalHandler)

    def refresh_view(self):
        pass

    def view_month(self):
        pass

    def view_day(self):
        pass
        
    def view_event(self):
        pass
    

class GladeHelper:
    def __init__(self, glade_file, handler):
        self.widgets = libglade.GladeXML(glade_file)
        self.widgets.signal_autoconnect(handler.__dict__)

    def __getitem__(self, key):
        return self.widgets.get_widget(key)


class EventSignalHandler:
    def on_edit_button_clicked(widget,*args):
        view = widget.get_data("view")

    def on_cancel_button_clicked(widget,*args):
        view = widget.get_data("view")

    def on_save_button_clicked(widget,*args):
        view = widget.get_data("view")
        
    def on_window_destroy(*args):
        gtk.mainquit()
